Index: mediaportal/WindowPlugins/GUIVideoFiles/GUIVideoFullscreen.cs
===================================================================
--- mediaportal/WindowPlugins/GUIVideoFiles/GUIVideoFullscreen.cs	(revision 26873)
+++ mediaportal/WindowPlugins/GUIVideoFiles/GUIVideoFullscreen.cs	(working copy)
@@ -30,6 +30,8 @@
 using MediaPortal.Video.Database;
 using MediaPortal.Player.Subtitles;
 using Action = MediaPortal.GUI.Library.Action;
+using MediaPortal.Player.PostProcessing;
+using FFDShow;
 
 namespace MediaPortal.GUI.Video
 {
@@ -712,14 +714,15 @@
               g_Player.SwitchToNextAudio();
 
               String language = g_Player.AudioLanguage(g_Player.CurrentAudioStream);
-              if (String.Equals(language, "Audio") || String.Equals(language, ""))
+              String languageType = g_Player.AudioType(g_Player.CurrentAudioStream);
+              if (languageType == Strings.Unknown || string.IsNullOrEmpty(languageType))
               {
-                msg.Label = string.Format("{0} ({1}/{2})", g_Player.AudioType(g_Player.CurrentAudioStream),
+                msg.Label = string.Format("{0} ({1}/{2})", language,
                                           g_Player.CurrentAudioStream + 1, g_Player.AudioStreams);
               }
               else
               {
-                msg.Label = string.Format("{0}, {1} ({2}/{3})", language, g_Player.AudioType(g_Player.CurrentAudioStream),
+                msg.Label = string.Format("{0} [{1}] ({2}/{3})", language, languageType.TrimEnd(),
                                           g_Player.CurrentAudioStream + 1, g_Player.AudioStreams);
               }
 
@@ -759,17 +762,42 @@
 
         case Action.ActionType.ACTION_NEXT_SUBTITLE:
           {
-            if (g_Player.SubtitleStreams > 0)
+            string[] subFiles = g_Player.SubtitleFiles;
+            int subStreamsCount = g_Player.SubtitleStreams;
+            if (subStreamsCount > 0 || subFiles.Length > 0)
             {
               _showStatus = true;
               _timeStatusShowTime = (DateTime.Now.Ticks / 10000);
               GUIMessage msg = new GUIMessage(GUIMessage.MessageType.GUI_MSG_LABEL_SET, GetID, 0,
                                               (int)Control.LABEL_ROW1, 0, 0, null);
-              g_Player.SwitchToNextSubtitle();
+              g_Player.SwitchToNextSubtitleSub();
               if (g_Player.EnableSubtitle)
               {
-                msg.Label = string.Format("{0} ({1}/{2})", g_Player.SubtitleLanguage(g_Player.CurrentSubtitleStream),
-                                          g_Player.CurrentSubtitleStream + 1, g_Player.SubtitleStreams);
+                if (g_Player.SubtitleFile != null)
+                {
+                  string subFile = g_Player.SubtitleFile;
+                  int subIndex = 0;
+                  for (int i = 0; i < subFiles.Length; i++)
+                  {
+                    if (subFile.Equals(subFiles[i])) { subIndex = i; break; }
+                  }
+                  msg.Label = string.Format("{0} ({1}/{2})",
+                    FFDShowAPI.getFileName(g_Player.SubtitleFile, FFDShowAPI.FileNameMode.FileNameLanguage),
+                    subStreamsCount + subIndex + 1, subStreamsCount + subFiles.Length);
+                }
+                else
+                {
+                  int streamId = g_Player.CurrentSubtitleStream;
+                  string strName = g_Player.SubtitleName(streamId);
+                  string langName = g_Player.SubtitleLanguage(streamId);
+                  if (!string.IsNullOrEmpty(strName))
+                    msg.Label = string.Format("{0} [{1}] ({2}/{3})", langName, strName.TrimStart(),
+                      streamId + 1, subStreamsCount + subFiles.Length);
+                  else
+                    msg.Label = string.Format("{0} ({1}/{2})", langName,
+                      streamId + 1, subStreamsCount + subFiles.Length);
+
+                }
               }
               else
               {
@@ -1195,13 +1223,20 @@
         dlg.AddLocalizedString(200059); // Audio dual mono mode menu
       }
 
-      // SubTitle stream selection, show only when there exists any streams,
+      // SubTitle stream and/or files selection, show only when there exists any streams,
       //    dialog shows then the streams and an item to disable them
-      if (g_Player.SubtitleStreams > 0)
+      if (g_Player.SubtitleStreams > 0 || g_Player.SubtitleFiles.Length > 0)
       {
         dlg.AddLocalizedString(462);
       }
 
+      // If the decoder supports postprocessing features (FFDShow)
+      if (g_Player.HasPostprocessing)
+      {
+        dlg.AddLocalizedString(200073);
+      }
+
+
       dlg.AddLocalizedString(970); // Previous window
       if (g_Player.IsDVD)
       {
@@ -1239,6 +1274,9 @@
         case 462:
           ShowSubtitleStreamsMenu();
           break;
+        case 200073:
+          ShowPostProcessingMenu();
+          break;
         case 1064:
           ShowBookmarksMenu();
           break;
@@ -1416,13 +1454,13 @@
       for (int i = 0; i < count; i++)
       {
         string audioType = g_Player.AudioType(i);
-        if (audioType == Strings.Unknown || String.Equals(audioType, ""))
+        if (audioType == Strings.Unknown || string.IsNullOrEmpty(audioType))
         {
           dlg.Add(g_Player.AudioLanguage(i));
         }
         else
         {
-          dlg.Add(String.Format("{0}: {1}", g_Player.AudioLanguage(i), audioType));
+          dlg.Add(String.Format("{0} [{1}]", g_Player.AudioLanguage(i), audioType.TrimEnd()));
         }
       }
 
@@ -1481,9 +1519,9 @@
       dlg.AddLocalizedString(519); // disable Subtitles
 
       // get the number of subtitles in the current movie
-      int count = g_Player.SubtitleStreams;
+      int nbSubStreams = g_Player.SubtitleStreams;
       // cycle through each subtitle and add it to our list control
-      for (int i = 0; i < count; ++i)
+      for (int i = 0; i < nbSubStreams; ++i)
       {
         // remove (English) in: "English (English)", should be done by gplayer
         string strLang = g_Player.SubtitleLanguage(i);
@@ -1492,18 +1530,61 @@
         {
           strLang = strLang.Substring(0, ipos);
         }
-        if (!string.IsNullOrEmpty(strLang))
+        string strName = g_Player.SubtitleName(i);
+        if (!string.IsNullOrEmpty(strName))
+        {
+          dlg.Add(String.Format("{0} [{1}]", strLang.TrimEnd(), strName.TrimStart()));
+        }
+        else
+        {
           dlg.Add(strLang);
-      }
-
-      // select/focus the subtitle, which is active atm
-      if (g_Player.EnableSubtitle)
+        }
+      } //This is Sebastiii unsupported release version.
+       
+      // select/focus the subtitle, which is active atm.
+      // There may be no subtitle streams selected at all (-1), which happens when a subtitle file is used instead
+      if (g_Player.EnableSubtitle && nbSubStreams > 0)
       {
-        dlg.SelectedLabel = g_Player.CurrentSubtitleStream + 1;
+        int subStream = g_Player.CurrentSubtitleStream;
+        if (subStream != -1) dlg.SelectedLabel = subStream + 1;
       }
       else
+        dlg.SelectedLabel = 0;
+
+      string currentSubFile = g_Player.SubtitleFile;
+      string[] subFiles = null;
+      if (g_Player.SubtitleFiles.Length > 0)
       {
-        dlg.SelectedLabel = 0;
+        //TODO Add separator header
+        subFiles = g_Player.SubtitleFiles;
+
+        Log.Info("Current subtitle file " + ((currentSubFile != null) ? currentSubFile : "None"));
+        int index = -1;
+        // First scan if the current subtitles file is in the list, otherwise add it
+        if (currentSubFile != null && !currentSubFile.Equals(""))
+        {
+          for (int i = 0; i < subFiles.Length; i++)
+          {
+            if (currentSubFile.Equals(subFiles[i]))
+            {
+              index = i;
+              break;
+            }
+          }
+          if (index == -1) // The current subtitle file is not in the list, add it on top of it
+          {
+            dlg.Add(currentSubFile);
+            index = 0;
+          }
+        }
+        for (int i = 0; i < subFiles.Length; i++)
+        {
+          // Store short file name in Label and full file path in Label2
+          GUIListItem item = new GUIListItem(FFDShowAPI.getFileName(subFiles[i], FFDShowAPI.FileNameMode.FileNameLanguage));
+          item.Path = subFiles[i];
+          dlg.Add(item);
+        }
+        if (index != -1) dlg.SelectedLabel = nbSubStreams + index + 1;
       }
 
       // show dialog and wait for result
@@ -1521,14 +1602,67 @@
       }
       else
       {
-        if (dlg.SelectedLabel != g_Player.CurrentSubtitleStream + 1)
+        if (dlg.SelectedLabel - 1 >= nbSubStreams)  // Subtitles file
         {
+          string subFile = subFiles[dlg.SelectedLabel - 1 - nbSubStreams];
+          Log.Info("Subtitle file selected : " + subFile);
+          if (currentSubFile == null || !subFile.Equals(currentSubFile))
+            g_Player.SubtitleFile = subFile;
+        }
+        else if (dlg.SelectedLabel != g_Player.CurrentSubtitleStream + 1)
+        {
+          Log.Info("Subtitle stream selected : " + (dlg.SelectedLabel - 1));
           g_Player.CurrentSubtitleStream = dlg.SelectedLabel - 1;
         }
         g_Player.EnableSubtitle = true;
       }
     }
 
+    private void ShowPostProcessingMenu()
+    {
+      if (dlg == null)
+      {
+        return;
+      }
+
+      do
+      {
+        dlg.Reset();
+        dlg.SetHeading(200073); // Postprocessing
+        IPostProcessingEngine engine = PostProcessingEngine.GetInstance();
+        // Deblocking
+        dlg.Add(String.Format("{0} {1}", GUILocalizeStrings.Get(200074), (engine.EnablePostProcess) ? GUILocalizeStrings.Get(461) : ""));
+        // Resize
+        dlg.Add(String.Format("{0} {1}", GUILocalizeStrings.Get(200075), (engine.EnableResize) ? GUILocalizeStrings.Get(461) : ""));
+        // Crop
+        dlg.Add(String.Format("{0} {1}", GUILocalizeStrings.Get(200078), (engine.EnableCrop) ? GUILocalizeStrings.Get(461) : ""));
+        // Deinterlace
+        dlg.Add(String.Format("{0} {1}", GUILocalizeStrings.Get(200077), (engine.EnableDeinterlace) ? GUILocalizeStrings.Get(461) : ""));
+        dlg.AddLocalizedString(970); // Previous window
+        dlg.SelectedLabel = 0;
+
+        // show dialog and wait for result
+        _IsDialogVisible = true;
+        dlg.DoModal(GetID);
+        if (dlg.SelectedId == 970)
+        {
+          // switch back to previous window
+          _IsDialogVisible = false;
+          GUIWindowManager.ShowPreviousWindow();
+          return;
+        }
+
+        switch (dlg.SelectedLabel)
+        {
+          case 0: engine.EnablePostProcess = !engine.EnablePostProcess; break;
+          case 1: engine.EnableResize = !engine.EnableResize; break;
+          case 2: engine.EnableCrop = !engine.EnableCrop; break;
+          case 3: engine.EnableDeinterlace = !engine.EnableDeinterlace; break;
+        }
+      } while (dlg.SelectedId != -1);
+      _IsDialogVisible = false;
+    }
+
     private void ShowAspectRatioMenu()
     {
       if (dlg == null)
Index: mediaportal/WindowPlugins/GUIVideoFiles/GUIVideoOSD.cs
===================================================================
--- mediaportal/WindowPlugins/GUIVideoFiles/GUIVideoOSD.cs	(revision 26873)
+++ mediaportal/WindowPlugins/GUIVideoFiles/GUIVideoOSD.cs	(working copy)
@@ -25,6 +25,8 @@
 using MediaPortal.Playlists;
 using MediaPortal.Video.Database;
 using Action = MediaPortal.GUI.Library.Action;
+using MediaPortal.Player.PostProcessing;
+using FFDShow;
 
 namespace MediaPortal.GUI.Video
 {
@@ -65,6 +67,14 @@
       OSD_CONTRASTLABEL = 753,
       OSD_GAMMA = 706,
       OSD_GAMMALABEL = 754,
+      OSD_VIDEO_POSTPROC_DEBLOCK_ONOFF = 707,
+      OSD_VIDEO_POSTPROC_RESIZE_ONOFF = 708,
+      //OSD_VIDEO_POSTPROC_CROP_ONOFF = 709,
+      OSD_VIDEO_POSTPROC_CROP_VERTICAL_LABEL = 710,
+      OSD_VIDEO_POSTPROC_CROP_VERTICAL = 711,
+      OSD_VIDEO_POSTPROC_CROP_HORIZONTAL_LABEL = 712,
+      OSD_VIDEO_POSTPROC_CROP_HORIZONTAL = 713,   
+      OSD_VIDEO_POSTPROC_DEINTERLACE_ONOFF = 714,
       OSD_SUBTITLE_DELAY = 800,
       OSD_SUBTITLE_DELAY_LABEL = 850,
       OSD_SUBTITLE_ONOFF = 801,
@@ -523,6 +533,16 @@
                 // set the controls values
                 float fPercent = (float)(100 * (g_Player.CurrentPosition / g_Player.Duration));
                 SetSliderValue(0.0f, 100.0f, (float)fPercent, (int)Controls.OSD_VIDEOPOS);
+                bool hasPostProc = g_Player.HasPostprocessing;
+                if (hasPostProc)
+                {
+                    IPostProcessingEngine engine = PostProcessingEngine.GetInstance();
+                    SetCheckmarkValue(engine.EnablePostProcess, (int)Controls.OSD_VIDEO_POSTPROC_DEBLOCK_ONOFF);
+                    SetCheckmarkValue(engine.EnableResize, (int)Controls.OSD_VIDEO_POSTPROC_RESIZE_ONOFF);
+                    //SetCheckmarkValue(engine.EnableCrop, (int)Controls.OSD_VIDEO_POSTPROC_CROP_ONOFF);
+                    SetCheckmarkValue(engine.EnableDeinterlace, (int)Controls.OSD_VIDEO_POSTPROC_DEINTERLACE_ONOFF);
+                    UpdatePostProcessing();
+                }
 
 
                 // SetCheckmarkValue(g_stSettings.m_bNonInterleaved, Controls.OSD_NONINTERLEAVED);
@@ -542,6 +562,15 @@
                 ShowControl(GetID, (int)Controls.OSD_CONTRASTLABEL);
                 ShowControl(GetID, (int)Controls.OSD_GAMMA);
                 ShowControl(GetID, (int)Controls.OSD_GAMMALABEL);
+                ShowControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_DEBLOCK_ONOFF);
+                ShowControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_RESIZE_ONOFF);
+                //ShowControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_ONOFF);
+                ShowControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_DEINTERLACE_ONOFF);
+                ShowControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_VERTICAL);
+                ShowControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_HORIZONTAL);
+                ShowControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_VERTICAL_LABEL);
+                ShowControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_HORIZONTAL_LABEL);
+                  
                 FocusControl(GetID, (int)Controls.OSD_VIDEOPOS, 0); // set focus to the first control in our group
               }
             }
@@ -584,6 +613,13 @@
       SetSliderValue(0.0f, 100.0f, (float)fGamma, (int)Controls.OSD_GAMMA);
     }
 
+    private void UpdatePostProcessing()
+    {
+        IPostProcessingEngine engine = PostProcessingEngine.GetInstance();
+        SetSliderValue(0.0f, 100.0f, (float)engine.CropVertical, (int)Controls.OSD_VIDEO_POSTPROC_CROP_VERTICAL);
+        SetSliderValue(0.0f, 100.0f, (float)engine.CropHorizontal, (int)Controls.OSD_VIDEO_POSTPROC_CROP_HORIZONTAL);
+    }
+
     private void SetVideoProgress()
     {
       if (g_Player.Playing)
@@ -683,6 +719,15 @@
       HideControl(GetID, (int)Controls.OSD_GAMMA);
       HideControl(GetID, (int)Controls.OSD_GAMMALABEL);
 
+      HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_DEBLOCK_ONOFF);
+      HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_RESIZE_ONOFF);
+      //HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_ONOFF);
+      HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_DEINTERLACE_ONOFF);
+      HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_VERTICAL);
+      HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_HORIZONTAL);
+      HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_VERTICAL_LABEL);
+      HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_CROP_HORIZONTAL_LABEL);
+
       HideControl(GetID, (int)Controls.OSD_CONTRAST);
       HideControl(GetID, (int)Controls.OSD_CONTRASTLABEL);
 
@@ -891,6 +936,16 @@
                   }
                   break;
         */
+        case (int)Controls.OSD_VIDEO_POSTPROC_DEBLOCK_ONOFF:
+            {
+              PostProcessingEngine.GetInstance().EnablePostProcess = !PostProcessingEngine.GetInstance().EnablePostProcess;
+              break;
+            }
+        case (int)Controls.OSD_VIDEO_POSTPROC_RESIZE_ONOFF:
+            {
+                PostProcessingEngine.GetInstance().EnableResize = !PostProcessingEngine.GetInstance().EnableResize;
+              break;
+            }
         case (int)Controls.OSD_SUBTITLE_ONOFF:
           {
             g_Player.EnableSubtitle = !g_Player.EnableSubtitle;
@@ -903,7 +958,20 @@
               GUIMessage msg = new GUIMessage(GUIMessage.MessageType.GUI_MSG_ITEM_SELECTED, GetID, 0,
                                               (int)Controls.OSD_SUBTITLE_LIST, 0, 0, null);
               OnMessage(msg); // retrieve the selected list item
-              g_Player.CurrentSubtitleStream = msg.Param1; // set the current subtitle
+              if (msg.Param1 >= g_Player.SubtitleStreams) // Subtitle file
+              {
+                  msg = new GUIMessage(GUIMessage.MessageType.GUI_MSG_GET_SELECTED_ITEM, GetID, 0,
+                                              (int)Controls.OSD_SUBTITLE_LIST, 0, 0, null);
+                  OnMessage(msg); // retrieve the selected list item
+                  GUIListItem item = (GUIListItem)msg.Object;
+                  Log.Info("Subtitle file selected " + item.Path);
+                  g_Player.SubtitleFile = item.Path; // set the current subtitle file
+              }
+              else
+              {
+                  Log.Info("Subtitle stream selected " + msg.Label);
+                  g_Player.CurrentSubtitleStream = msg.Param1; // set the current subtitle
+              }
               PopulateSubTitles();
             }
           }
@@ -925,6 +993,26 @@
             }
           }
           break;
+        case (int)Controls.OSD_VIDEO_POSTPROC_CROP_VERTICAL:
+          {
+              GUISliderControl pControl = (GUISliderControl)GetControl(iControlID);
+              if (null != pControl)
+              {
+                  PostProcessingEngine.GetInstance().CropVertical = pControl.Percentage;
+                  UpdatePostProcessing();
+              }
+          }
+          break;
+        case (int)Controls.OSD_VIDEO_POSTPROC_CROP_HORIZONTAL:
+          {
+              GUISliderControl pControl = (GUISliderControl)GetControl(iControlID);
+              if (null != pControl)
+              {
+                  PostProcessingEngine.GetInstance().CropHorizontal = pControl.Percentage;
+                  UpdatePostProcessing();
+              }
+          }
+          break;
       }
     }
 
@@ -1036,7 +1124,7 @@
     private void PopulateSubTitles()
     {
       // get the number of subtitles in the current movie
-      int iValue = g_Player.SubtitleStreams;
+      int subStreamsCount = g_Player.SubtitleStreams;
 
       // tell the list control not to show the page x/y spin control
       GUIListControl pControl = (GUIListControl)GetControl((int)Controls.OSD_SUBTITLE_LIST);
@@ -1055,39 +1143,91 @@
 
       // cycle through each subtitle and add it to our list control
       int currentSubtitleStream = g_Player.CurrentSubtitleStream;
-      for (int i = 0; i < iValue; ++i)
+      for (int i = 0; i < subStreamsCount; ++i)
       {
         string strItem;
         string strLang = g_Player.SubtitleLanguage(i);
+        string strName = g_Player.SubtitleName(i);
+        // formats right label2 to '[active]'
+        string strActive = (currentSubtitleStream == i) ? strActiveLabel : null;
         int ipos = strLang.IndexOf("(");
         if (ipos > 0)
         {
           strLang = strLang.Substring(0, ipos);
         }
-        if (currentSubtitleStream == i) // this subtitle is active, show as such
+        //if (strName != null && !strName.Equals(""))
+        if (strName != null && !strName.Equals("") && !strName.Equals(strLang)) //Sebastiii
         {
-          // formats to 'Subtitle X [active]'
-          strItem = String.Format(strLang + " " + strActiveLabel); // this audio stream is active, show as such
+          if (strLang != null && !strLang.Equals(""))
+            // formats to 'Subtitle name (language)'
+            strItem = String.Format(strName + " (" + strLang + ")");
+          else
+            // formats to 'Subtitle name'
+            strItem = String.Format(strName);
         }
         else
-        {
-          // formats to 'Subtitle X'
+          // formats to 'Language'
           strItem = String.Format(strLang);
-        }
 
         // create a list item object to add to the list
-        GUIListItem pItem = new GUIListItem();
-        pItem.Label = strItem;
+        GUIListItem pItem = new GUIListItem(strItem);
 
+        if (strActive != null) pItem.Label2 = strActive;
+
         // add it ...
         GUIMessage msg2 = new GUIMessage(GUIMessage.MessageType.GUI_MSG_LABEL_ADD, GetID, 0,
                                          (int)Controls.OSD_SUBTITLE_LIST, 0, 0, pItem);
         OnMessage(msg2);
       }
 
+      string[] subFiles = g_Player.SubtitleFiles;
+      string currentSubFile = g_Player.SubtitleFile;
+      int subFileIndex = -1;
+      if (subFiles.Length > 0)
+      {
+        Log.Info("Current subtitle file " + ((currentSubFile != null) ? currentSubFile : "None"));
+
+        // First scan if the current subtitles file is in the list, otherwise add it
+        if (currentSubFile != null && !currentSubFile.Equals(""))
+        {
+          for (int i = 0; i < subFiles.Length; i++)
+          {
+            if (currentSubFile.Equals(subFiles[i]))
+            {
+              subFileIndex = i;
+              break;
+            }
+          }
+          if (subFileIndex == -1) // The current subtitle file is not in the list, add it on top of it
+          {
+            // create a list item object to add to the list
+            GUIListItem pItem = new GUIListItem();
+            pItem.Label = currentSubFile;
+
+            // add it ...
+            GUIMessage msg2 = new GUIMessage(GUIMessage.MessageType.GUI_MSG_LABEL_ADD, GetID, 0,
+                                             (int)Controls.OSD_SUBTITLE_LIST, 0, 0, pItem);
+            OnMessage(msg2);
+            subFileIndex = 0;
+          }
+        }
+        for (int i = 0; i < subFiles.Length; i++)
+        {
+          // create a list item object to add to the list
+          GUIListItem pItem = new GUIListItem();
+          pItem.Label = FFDShowAPI.getFileName(subFiles[i], FFDShow.FFDShowAPI.FileNameMode.FileNameWithoutExtension);
+          pItem.Path = subFiles[i];
+
+          // add it ...
+          GUIMessage msg2 = new GUIMessage(GUIMessage.MessageType.GUI_MSG_LABEL_ADD, GetID, 0,
+                                           (int)Controls.OSD_SUBTITLE_LIST, 0, 0, pItem);
+          OnMessage(msg2);
+        }
+      }
+
       // set the current active subtitle as the selected item in the list control
       GUIMessage msgSet = new GUIMessage(GUIMessage.MessageType.GUI_MSG_ITEM_SELECT, GetID, 0,
-                                         (int)Controls.OSD_SUBTITLE_LIST, g_Player.CurrentSubtitleStream, 0, null);
+        (int)Controls.OSD_SUBTITLE_LIST, (subFileIndex == -1) ? currentSubtitleStream : (subFileIndex + subStreamsCount ), 0, null);
       OnMessage(msgSet);
     }
 
@@ -1175,6 +1315,8 @@
       HideControl(GetID, (int)Controls.OSD_SUBTITLE_DELAY_LABEL);
       HideControl(GetID, (int)Controls.OSD_SUBTITLE_ONOFF);
       HideControl(GetID, (int)Controls.OSD_SUBTITLE_LIST);
+      HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_DEBLOCK_ONOFF);
+      HideControl(GetID, (int)Controls.OSD_VIDEO_POSTPROC_RESIZE_ONOFF);
 
       ToggleButton((int)Controls.OSD_MUTE, false);
       ToggleButton((int)Controls.OSD_SUBTITLES, false);
Index: TvEngine3/TVLibrary/TvPlugin/TvPlugin/TvFullScreen.cs
===================================================================
--- TvEngine3/TVLibrary/TvPlugin/TvPlugin/TvFullScreen.cs	(revision 26873)
+++ TvEngine3/TVLibrary/TvPlugin/TvPlugin/TvFullScreen.cs	(working copy)
@@ -42,7 +42,10 @@
 using Timer = System.Timers.Timer;
 using System.Runtime.Remoting;
 using Action = MediaPortal.GUI.Library.Action;
+using MediaPortal.Player.PostProcessing;
+using FFDShow;
 
+
 #endregion
 
 namespace TvPlugin
@@ -1561,6 +1564,19 @@
         dlg.AddLocalizedString(200059); // Audio dual mono mode menu
       }
 
+      // SubTitle stream, show only when there exists any streams,
+      //    dialog shows then the streams and an item to disable them
+      if (g_Player.SubtitleStreams > 0 || g_Player.SubtitleFiles.Length > 0)
+      {
+        dlg.AddLocalizedString(462);
+      }
+
+      // If the decoder supports postprocessing features (FFDShow)
+      if (g_Player.HasPostprocessing)
+      {
+        dlg.AddLocalizedString(200073);
+      }
+
       dlg.AddLocalizedString(11000); // Crop settings
 
       if (!g_Player.IsTVRecording)
@@ -1790,6 +1806,14 @@
         case 200091:
           ShowChapterStreamsMenu();
           break;
+
+        case 462:
+          ShowSubtitleStreamsMenu();
+          break;
+
+        case 200073:
+          ShowPostProcessingMenu();
+          break;
       }
     }
 
@@ -2229,6 +2253,163 @@
       TVHome.Navigator.ZapToChannel(lmap.ReferringLinkedChannel(), false);
     }
 
+    private void ShowSubtitleStreamsMenu() //Sebastiii
+    {
+      if (dlg == null)
+      {
+        return;
+      }
+      dlg.Reset();
+      dlg.SetHeading(462); // SubTitle Streams
+
+      dlg.AddLocalizedString(519); // disable Subtitles
+
+      // get the number of subtitles in the current movie
+      int nbSubStreams = g_Player.SubtitleStreams;
+      // cycle through each subtitle and add it to our list control
+      for (int i = 0; i < nbSubStreams; ++i)
+      {
+        // remove (English) in: "English (English)", should be done by gplayer
+        string strLang = g_Player.SubtitleLanguage(i);
+        int ipos = strLang.IndexOf("(");
+        if (ipos > 0)
+        {
+          strLang = strLang.Substring(0, ipos);
+        }
+        /*string strName = g_Player.SubtitleName(i);
+        if (!string.IsNullOrEmpty(strName))
+        {
+          dlg.Add(String.Format("{0} [{1}]", strLang.TrimEnd(), strName.TrimStart()));
+        }
+        else*/
+        {
+          dlg.Add(strLang);
+        }
+      } //This is Sebastiii unsupported release version.
+
+      // select/focus the subtitle, which is active atm.
+      // There may be no subtitle streams selected at all (-1), which happens when a subtitle file is used instead
+      if (g_Player.EnableSubtitle && nbSubStreams > 0)
+      {
+        int subStream = g_Player.CurrentSubtitleStream;
+        if (subStream != -1) dlg.SelectedLabel = subStream + 1;
+      }
+      else
+        dlg.SelectedLabel = 0;
+
+      /*string currentSubFile = g_Player.SubtitleFile;
+      string[] subFiles = null;
+      if (g_Player.SubtitleFiles.Length > 0)
+      {
+        //TODO Add separator header
+        subFiles = g_Player.SubtitleFiles;
+
+        Log.Info("Current subtitle file " + ((currentSubFile != null) ? currentSubFile : "None"));
+        int index = -1;
+        // First scan if the current subtitles file is in the list, otherwise add it
+        if (currentSubFile != null && !currentSubFile.Equals(""))
+        {
+          for (int i = 0; i < subFiles.Length; i++)
+          {
+            if (currentSubFile.Equals(subFiles[i]))
+            {
+              index = i;
+              break;
+            }
+          }
+          if (index == -1) // The current subtitle file is not in the list, add it on top of it
+          {
+            dlg.Add(currentSubFile);
+            index = 0;
+          }
+        }
+        for (int i = 0; i < subFiles.Length; i++)
+        {
+          // Store short file name in Label and full file path in Label2
+          GUIListItem item = new GUIListItem(FFDShowAPI.getFileName(subFiles[i], FFDShowAPI.FileNameMode.FileNameLanguage));
+          item.Path = subFiles[i];
+          dlg.Add(item);
+        }
+        if (index != -1) dlg.SelectedLabel = nbSubStreams + index + 1;
+      }*/
+
+      // show dialog and wait for result
+      _isDialogVisible = true;
+      dlg.DoModal(GetID);
+      _isDialogVisible = false;
+
+      if (dlg.SelectedId == -1)
+      {
+        return;
+      }
+      if (dlg.SelectedLabel == 0)
+      {
+        g_Player.EnableSubtitle = false;
+      }
+      else
+      {
+        /*if (dlg.SelectedLabel - 1 >= nbSubStreams)  // Subtitles file
+        {
+          string subFile = subFiles[dlg.SelectedLabel - 1 - nbSubStreams];
+          Log.Info("Subtitle file selected : " + subFile);
+          if (currentSubFile == null || !subFile.Equals(currentSubFile))
+            g_Player.SubtitleFile = subFile;
+        }*/
+        /*else*/
+        if (dlg.SelectedLabel != g_Player.CurrentSubtitleStream + 1)
+        {
+          Log.Info("Subtitle stream selected : " + (dlg.SelectedLabel - 1));
+          g_Player.CurrentSubtitleStream = dlg.SelectedLabel - 1;
+        }
+        g_Player.EnableSubtitle = true;
+      }
+    }
+
+    private void ShowPostProcessingMenu() //Sebastiii
+    {
+      if (dlg == null)
+      {
+        return;
+      }
+
+      do
+      {
+        dlg.Reset();
+        dlg.SetHeading(200073); // Postprocessing
+        IPostProcessingEngine engine = PostProcessingEngine.GetInstance();
+        // Deblocking
+        dlg.Add(String.Format("{0} {1}", GUILocalizeStrings.Get(200074), (engine.EnablePostProcess) ? GUILocalizeStrings.Get(461) : ""));
+        // Resize
+        dlg.Add(String.Format("{0} {1}", GUILocalizeStrings.Get(200075), (engine.EnableResize) ? GUILocalizeStrings.Get(461) : ""));
+        // Crop
+        dlg.Add(String.Format("{0} {1}", GUILocalizeStrings.Get(200078), (engine.EnableCrop) ? GUILocalizeStrings.Get(461) : ""));
+        // Deinterlace
+        dlg.Add(String.Format("{0} {1}", GUILocalizeStrings.Get(200077), (engine.EnableDeinterlace) ? GUILocalizeStrings.Get(461) : ""));
+        dlg.AddLocalizedString(970); // Previous window
+        dlg.SelectedLabel = 0;
+
+        // show dialog and wait for result
+        _isDialogVisible = true;
+        dlg.DoModal(GetID);
+        if (dlg.SelectedId == 970)
+        {
+          // switch back to previous window
+          _isDialogVisible = false;
+          GUIWindowManager.ShowPreviousWindow();
+          return;
+        }
+
+        switch (dlg.SelectedLabel)
+        {
+          case 0: engine.EnablePostProcess = !engine.EnablePostProcess; break;
+          case 1: engine.EnableResize = !engine.EnableResize; break;
+          case 2: engine.EnableCrop = !engine.EnableCrop; break;
+          case 3: engine.EnableDeinterlace = !engine.EnableDeinterlace; break;
+        }
+      } while (dlg.SelectedId != -1);
+      _isDialogVisible = false;
+    }
+
     public override void Process()
     {
       CheckTimeOuts();
